> For the complete documentation index, see [llms.txt](https://docs.nucleusearn.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nucleusearn.io/nucleus-architecture/smart-contracts/contracts/interfaces/istaking/iunsteth.md).

# IUNSTETH

[Git Source](https://github.com/Ion-Protocol/nucleus-boring-vault/blob/cc0b494b83e17b9b169a73b96050d2810b690477/src/interfaces/IStaking.sol)

## Functions

### getWithdrawalStatus

```solidity
function getWithdrawalStatus(uint256[] calldata _requestIds)
    external
    view
    returns (WithdrawalRequestStatus[] memory statuses);
```

### requestWithdrawals

```solidity
function requestWithdrawals(
    uint256[] calldata _amounts,
    address _owner
)
    external
    returns (uint256[] memory requestIds);
```

### claimWithdrawal

```solidity
function claimWithdrawal(uint256 _requestId) external;
```

### claimWithdrawals

```solidity
function claimWithdrawals(uint256[] calldata _requestIds, uint256[] calldata _hints) external;
```

### finalize

```solidity
function finalize(uint256 _lastRequestIdToBeFinalized, uint256 _maxShareRate) external payable;
```

### getRoleMember

```solidity
function getRoleMember(bytes32 role, uint256 index) external view returns (address);
```

### FINALIZE\_ROLE

```solidity
function FINALIZE_ROLE() external view returns (bytes32);
```

### getLastFinalizedRequestId

```solidity
function getLastFinalizedRequestId() external view returns (uint256);
```

### getLastCheckpointIndex

```solidity
function getLastCheckpointIndex() external view returns (uint256);
```

### findCheckpointHints

```solidity
function findCheckpointHints(
    uint256[] memory requestIds,
    uint256 firstIndex,
    uint256 lastIndex
)
    external
    view
    returns (uint256[] memory);
```

### getClaimableEther

```solidity
function getClaimableEther(
    uint256[] memory requestIds,
    uint256[] memory hints
)
    external
    view
    returns (uint256[] memory);
```

## Structs

### WithdrawalRequestStatus

```solidity
struct WithdrawalRequestStatus {
    uint256 amountOfStETH;
    uint256 amountOfShares;
    address owner;
    uint256 timestamp;
    bool isFinalized;
    bool isClaimed;
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nucleusearn.io/nucleus-architecture/smart-contracts/contracts/interfaces/istaking/iunsteth.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
